#include <stdio.h>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>


using namespace std;


int string_to_int(const string& s) {
	int result;
	stringstream ss;
	ss << s;
	ss >> result;
	return result;
}


int main(int argc, char** argv) {
	freopen("input.txt", "w", stdout);
	int n = string_to_int(argv[1]);
	int w = string_to_int(argv[2]);
	int h = string_to_int(argv[3]);
	int l = string_to_int(argv[4]);
	int randseed = string_to_int(argv[5]);
	
	srand(randseed);
	vector<pair <int, int> > variants;
	int vs = w*h;
	variants.resize(vs);
	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			variants[(i-1) * w + j-1] = make_pair(j, i);
		}
	}
	
	printf("%d %d %d %d\n", n, w, h, l);
	for (int i = 0; i < n; i++) {
		int ind = (rand()*rand()) % vs;
		vs--;
		swap(variants[ind], variants[vs]);
		printf("%d %d  ", variants[vs].first, variants[vs].second);

	}
	fclose(stdout);
	return 0;
}
