#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>


#define SQR(X) ((X)*(X))


using namespace std;


class Point {
	friend istream& operator >> (istream& in, Point& p) {
		in >> p.x >> p.y;
		p.x--; p.y--;
		return in;
	}


private:
	int x, y;


public:
	Point(int _x = 0, int _y = 0): x(_x), y(_y) { };

	int dist2(const Point& p) const {
		return SQR(x - p.x) + SQR(y - p.y);
	}

};


Point point;
int n, w, h, l;


int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> n >> w >> h >> l;
	vector<Point> valid_point;
	vector<int> ans;
	for (int i = 0; i < n; i++) {
		cin >> point;
		bool isOk = true;
		for (vector<Point>::const_iterator it = valid_point.begin(); it < valid_point.end(); it++) {
			if (it->dist2(point) <= SQR(l)) {
				isOk = false;
				break;
			}
		}
		if (isOk) {
			valid_point.push_back(point);
			ans.push_back(i+1);
		}
	}
	cout << ans.size() << endl;
	for (vector<int>::const_iterator it = ans.begin(); it < ans.end(); it++) {
		cout << (*it) << endl;
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
